<template>
  <a-card :bordered="false">
    <div class="table-page-search-wrapper">
      <a-form layout="inline">
        <a-row :gutter="48">
          <a-col :md="8" :sm="24">
            <a-form-item label="关键字">
              <a-input v-model="queryParam.keyword" placeholder="请输入名称/编码"/>
            </a-form-item>
          </a-col>
          <a-col :md="8 || 24" :sm="24">
            <span class="table-page-search-submitButtons">
              <a-button type="primary" @click="$refs.table.refresh(true)">查询</a-button>
              <a-button style="margin-left: 8px" @click="resetSearchForm">重置</a-button>
            </span>
          </a-col>
        </a-row>
      </a-form>
    </div>

    <div class="table-operator">
      <a-button style="margin-left: 8px" v-if="$auth('sqarepartmanage-spare-part-info-export')" type="primary" icon="download" @click="doExport">导出</a-button>
    </div>

    <s-table
      ref="table"
      size="default"
      rowKey="id"
      :columns="columns"
      :data="loadData"
      :alert="options.alert"
      :rowSelection="options.rowSelection"
      showPagination="auto"
    >
      <span slot="status" slot-scope="text, record">
        <a @click="handleStore(record)">{{text||"无"}}</a>
      </span>

      <span slot="action" slot-scope="record">
        <template>
          <a @click="handleInStore(record)">入库记录</a>
          <a-divider type="vertical" />
          <a @click="handleOutStore(record)">出库记录</a>
          <a-divider type="vertical" />
          <a @click="handleSparePartUsed(record)">使用记录</a>
        </template>
      </span>
    </s-table>
    <base-form ref="baseModal" @ok="handleOk"/>
    <detail ref="detailModal"/>
    <storeList ref="storeListModal"/>
    <inStoreList ref="inStoreListModal"/>
    <outStoreList ref="outStoreListModal"/>
    <spare-part-used-select-modal ref="sparePartUsedSelectModal"/>
  </a-card>
</template>

<script>
import { STable, Ellipsis } from '@/components'
import BaseForm from './modules/BaseForm'
import Detail from './modules/Detail'
import StoreList from './modules/StoreList'
import InStoreList from './modules/InStoreList'
import OutStoreList from './modules/OutStoreList'
import SparePartUsedSelectModal from '@/views/sqarepartmanage/sparepartused/modules/SparePartUsedSelectModal'
import { getSparePartInfoPage, deleteSparePartInfos, fetchSparePartInfo, fetchStoreList, fetchInStoreList, fetchOutStoreList, exportSparePartInfo } from '@/api/sqarepartmanage/sparepartinfo'

export default {
  name: 'SparePartInfoList',
  components: {
    STable,
    Ellipsis,
    BaseForm,
    Detail,
    StoreList,
    InStoreList,
    OutStoreList,
    SparePartUsedSelectModal
  },
  data () {
    return {
      // 查询参数
      queryParam: {
      },
      // 表头
      columns: [

        {
          title: '备件编码',
          dataIndex: 'no'
        },
        {
          title: '备件名称',
          dataIndex: 'name'
        },
        {
          title: '备件类别',
          dataIndex: 'typeId',
          customRender: (text, record, index) => {
            return record.typeName
          }
        },
        {
          title: '等级',
          dataIndex: 'level',
          customRender: (text, record, index) => {
            return this.BaseTool.Object.getField(this.levelMap, text)
          }
        },

        {
          title: '当前库存',
          dataIndex: 'currentStock',
          scopedSlots: { customRender: 'status' }
        },
        {
          title: '最高库存',
          dataIndex: 'maxStock'
        },
        {
          title: '最低库存',
          dataIndex: 'minStock'
        },
         {
            title: '是否预警',
            dataIndex: 'minStock',
            customRender: (text, record, index) => {
                return record.currentStock<record.mixStock?"是":"否"
              }
          },
         {
          title: '生产商',
          dataIndex: 'producerId',
          customRender: (text, record, index) => {
            return record.producerName
          }
        },
        {
          title: '计量单位',
          dataIndex: 'unit',
          customRender: (text, record, index) => {
            return this.BaseTool.Object.getField(this.unitMap, text)
          }
        },
        {
          title: '备注',
          dataIndex: 'remark'
        },
        {
          title: '创建日期',
          dataIndex: 'createdTime'
        },
        {
          title: '操作',
          key: 'action',
          width: '400px',
          align: 'center',
          scopedSlots: { customRender: 'action' }
        }
      ],
      // 加载数据方法 必须为 Promise 对象
      loadData: parameter => {
        parameter = {
          ...parameter,
          ...this.queryParam,
          dataScope: {
            sortBy: 'desc',
            sortName: 'update_time'
          }
        }
        return getSparePartInfoPage(Object.assign(parameter, this.queryParam))
          .then(res => {
            return res.data
          })
      },
      selectedRowKeys: [],
      selectedRows: [],

      options: {
        alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
        rowSelection: {
          selectedRowKeys: this.selectedRowKeys,
          onChange: this.onSelectChange
        }
      },
      optionAlertShow: false
    }
  },
  created () {
    // 下拉框map
    this.levelMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SPARE_PART_INFO_LEVEL)
    this.unitMap = this.DictCache.getLabelByValueMapByType(this.DictCache.TYPE.SBINFO_UNIT)
    this.tableOption()
  },
  methods: {
    tableOption () {
      if (!this.optionAlertShow) {
        this.options = {
          alert: { show: true, clear: () => { this.selectedRowKeys = [] } },
          rowSelection: {
            selectedRowKeys: this.selectedRowKeys,
            onChange: this.onSelectChange,
            getCheckboxProps: record => ({
              props: {
                disabled: false,
                name: record.id
              }
            })
          }
        }
        this.optionAlertShow = true
      } else {
        this.options = {
          alert: false,
          rowSelection: null
        }
        this.optionAlertShow = false
      }
    },
    batchDelete (id) {
      let ids = []
      if (this.BaseTool.String.isBlank(id)) {
        const length = this.selectedRows.length
        if (length === 0) {
          this.$message.info('请选择要删除的记录')
          return
        }
        ids = this.selectedRows.map(item => item.id)
      } else {
        ids = [id]
      }
      deleteSparePartInfos(ids).then(res => {
        this.$message.info('删除成功')
        this.handleOk()
        this.$refs.table.clearSelected()
      })
    },
    handleEdit (record) {
      fetchSparePartInfo({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        modal.base(res.data)
      })
    },
    handleStore (record) {
      fetchStoreList({ id: record.id }).then(res => {
        const modal = this.$refs.storeListModal
        modal.base(res.data)
      })
    },
    handleInStore (record) {
      fetchInStoreList({ id: record.id }).then(res => {
        const modal = this.$refs.inStoreListModal
        modal.base(res.data)
      })
    },
    handleSparePartUsed (record) {
      this.$refs.sparePartUsedSelectModal.base({},{spareId:record.id})
    },
    handleOutStore (record) {
      fetchOutStoreList({ id: record.id }).then(res => {
        const modal = this.$refs.outStoreListModal
        modal.base(res.data)
      })
    },
    handleView (record) {
      fetchSparePartInfo({ id: record.id }).then(res => {
        const modal = this.$refs.detailModal
        modal.base(res.data)
      })
    },
    handleOk () {
      this.$refs.table.refresh()
    },
    onSelectChange (selectedRowKeys, selectedRows) {
      this.selectedRowKeys = selectedRowKeys
      this.selectedRows = selectedRows
    },
    resetSearchForm () {
      this.queryParam = {
      }
      this.$refs.table.refresh(true)
    },
    doExport () {
      const parameter = {
        ...this.queryParam
      }
      exportSparePartInfo(parameter).then(file => {
        this.BaseTool.UPLOAD.downLoadExportExcel(file)
      })
    },
    handleCopy (record) {
      fetchSparePartInfo({ id: record.id }).then(res => {
        const modal = this.$refs.baseModal
        res.data.id = null
        modal.base(res.data)
      })
    },
  }
}
</script>
